package tik_tok

import (
	zhios_third_party_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_third_party_api.git/utils"
	"encoding/json"
	"fmt"
	"github.com/tidwall/gjson"
)

func Activity(args map[string]string) []TikTokActivity {
	//args = map[string]string{
	//	"appkey":      "7136155008692651560",
	//	"appSecret":   "b132549f-f62c-491e-86f1-89af3658896a",
	//	"status":      "5",
	//	"search_type": "0",
	//	"sort_type":   "1",
	//	"page":        "1",
	//	"page_size":   "20",
	//	"acctoken":    "21af5cb7-6a14-455f-90f7-6807b5e6655f",
	//}
	params := map[string]interface{}{"status": args["status"], "search_type": args["search_type"], "sort_type": args["sort_type"], "page": args["page"], "page_size": args["page_size"]}
	send, err := Send(args["appkey"], args["appSecret"], "alliance.instituteColonelActivityList", params, args["acctoken"])
	var goodsList = make([]TikTokActivity, 0)
	if err != nil {
		return goodsList
	}
	product := gjson.Get(send, "data.activity_list").String()
	if err != nil || product == "" {
		return goodsList
	}
	err = json.Unmarshal([]byte(product), &goodsList)
	if err != nil {
		return goodsList
	}
	return goodsList

}
func TrusteeshipProduct(args map[string]string) ([]TikTokGoods, int64) {
	//args = map[string]string{
	//	"appkey":        "7136155008692651560",
	//	"appSecret":     "b132549f-f62c-491e-86f1-89af3658896a",
	//	"activity_id":   "437153",
	//	"search_type":   "0",
	//	"sort_type":     "1",
	//	"page":          "1",
	//	"page_size":     "20",
	//	"count":         "1",
	//	"product_info":  "3448990760731595786",
	//	"status":        "1",
	//	"retrieve_mode": "0",
	//	"acctoken":      "d67db7b0-1305-42f1-b378-bf583a6a5b48",
	//}
	params := map[string]interface{}{"status": args["status"], "page_size": args["page_size"], "page": args["page"], "retrieve_mode": args["retrieve_mode"]}
	params["status"] = "1"
	send, err := Send(args["appkey"], args["appSecret"], "buyin.colonel/trusteeshipList", params, args["acctoken"])
	fmt.Println(send)
	fmt.Println(err)
	var goodsList = make([]TikTokGoods, 0)
	product := gjson.Get(send, "data.data").String()
	if err != nil || product == "" {
		return goodsList, 0
	}
	var lmData struct {
		Data struct {
			Data  []TikTokGoodsLm `json:"data"`
			Total int64           `json:"total"`
		} `json:"data"`
	}
	err = json.Unmarshal([]byte(send), &lmData)
	if err != nil {
		return goodsList, 0
	}
	for _, v := range lmData.Data.Data {
		tmp := CommGoodsDetail(v)
		tmp.UpdateTime = v.UpdateTime
		goodsList = append(goodsList, tmp)
	}
	fmt.Println(string(zhios_third_party_utils.Serialize(goodsList)))
	return goodsList, lmData.Data.Total
}

func ActivityProduct(args map[string]string) ([]TikTokGoods, int64, string) {
	//args = map[string]string{
	//	"appkey":       "7136155008692651560",
	//	"appSecret":    "b132549f-f62c-491e-86f1-89af3658896a",
	//	"activity_id":  "437153",
	//	"search_type":  "0",
	//	"sort_type":    "1",
	//	"page":         "1",
	//	"count":        "1",
	//	"product_info": "3448990760731595786",
	//	"status":       "1",
	//	"acctoken":     "ff1a797c-a088-47bf-8c31-9784fa630c5e",
	//}
	params := map[string]interface{}{"status": args["status"], "activity_id": args["activity_id"], "search_type": args["search_type"], "sort_type": args["sort_type"], "page": args["page"], "count": args["count"]}
	if args["product_info"] != "" {
		params["product_info"] = args["product_info"]
	}
	if args["retrieve_mode"] != "" {
		params["retrieve_mode"] = args["retrieve_mode"]
	}
	if args["cursor"] != "" {
		params["cursor"] = args["cursor"]
	}
	send, err := Send(args["appkey"], args["appSecret"], "alliance.colonelActivityProduct", params, args["acctoken"])
	fmt.Println(send)
	fmt.Println(err)
	var goodsList = make([]TikTokGoods, 0)
	product := gjson.Get(send, "data.data").String()
	if err != nil || product == "" {
		return goodsList, 0, ""
	}
	var lmData struct {
		Data struct {
			Data       []TikTokGoodsLm `json:"data"`
			Total      int64           `json:"total"`
			NextCursor string          `json:"next_cursor"`
		} `json:"data"`
	}
	err = json.Unmarshal([]byte(send), &lmData)
	if err != nil {
		return goodsList, 0, ""
	}
	for _, v := range lmData.Data.Data {
		tmp := CommGoodsDetail(v)
		tmp.UpdateTime = v.UpdateTime
		goodsList = append(goodsList, tmp)
	}
	fmt.Println(string(zhios_third_party_utils.Serialize(goodsList)))
	return goodsList, lmData.Data.Total, lmData.Data.NextCursor
}
func ProductUrl(args map[string]string) map[string]string {
	//args = map[string]string{
	//	"appkey":      "7136155008692651560",
	//	"appSecret":   "b132549f-f62c-491e-86f1-89af3658896a",
	//	"product_url": "https://haohuo.jinritemai.com/views/product/detail?id=3566782589740130047&ins_activity_param=jXxRyGL&pick_source=jc2e3jF",
	//	"pick_extra":  "123",
	//	"acctoken":    "21af5cb7-6a14-455f-90f7-6807b5e6655f",
	//}
	params := map[string]interface{}{"product_url": args["product_url"], "pick_extra": args["pick_extra"]}
	send, err := Send(args["appkey"], args["appSecret"], "buyin.instPickSourceConvert", params, args["acctoken"])
	fmt.Println(send)
	fmt.Println(err)
	var data = map[string]string{}
	if err != nil {
		return data
	}
	data["product_url"] = gjson.Get(send, "data.product_url").String()

	return data
}

func TeamOrder(args map[string]string) *[]TikTokTeamOrder {
	params := map[string]interface{}{
		"size":      args["size"],
		"cursor":    args["cursor"],
		"order_ids": args["order_ids"],
	}
	send, err := Send(args["appkey"], args["appSecret"], "buyin.instituteOrderColonel", params, args["acctoken"])
	fmt.Println(send)
	fmt.Println(err)
	var goodsList *[]TikTokTeamOrder
	product := gjson.Get(send, "data").String()
	if err != nil || product == "" {
		return goodsList
	}
	var lmData struct {
		Data struct {
			Orders []TikTokTeamOrder `json:"orders"`
		} `json:"data"`
	}
	err = json.Unmarshal([]byte(send), &lmData)
	if err != nil {
		return goodsList
	}
	goodsList = &lmData.Data.Orders
	return goodsList
}
